#define UPDATE_BCK

#include <netcdf.h>

//constantes
//YREAL rdtflo=2*3600;
YREAL rdtflo=3600;
//YREAL rdtflo=1;
YREAL ur_dx=0;
YREAL ur_dy=0;
YREAL vr_dx=0;
YREAL vr_dy=0;


//Mode Forward ou assim;
typedef enum {ASSIM,FORW} assim_t;

assim_t tassim = ASSIM;

//Tableaux

//Variable d'état
YREAL umod[nlon][nlat][jptfl];
YREAL vmod[nlon][nlat][jptfl];
YREAL uwind[nlon][nlat][jptfl];
YREAL vwind[nlon][nlat][jptfl];
YREAL utotal[nlon][nlat][jptfl];
YREAL vtotal[nlon][nlat][jptfl];

//Background
YREAL ubck[nlon][nlat][jptfl];
YREAL vbck[nlon][nlat][jptfl];
int mask[nlon][nlat];

//Trajectoires des flotteurs (en points de grille)
YREAL piobs[jptfl][jpnfl];
YREAL pjobs[jptfl][jpnfl];
YREAL piret[jptfl][jpnfl];
YREAL pjret[jptfl][jpnfl];
short pmask[jptfl][jpnfl];

//FILTER COEFFICIENTS
#ifdef K_FILTER 
//YREAL c1;
//YREAL c2,c3,c4,c5;
//YREAL dtfil=26042000;
//YREAL dtfil=2.604166666666667e+07;

#ifdef INC_FIL
#include "fil_def.h"
#else
YREAL dtfil=200000;
#endif
#endif

#define ERR(e) {fprintf(stderr,"Error: %s\n", nc_strerror(e)); exit(EXIT_FAILURE);}
#define LONDIM "lon_interp"
#define LATDIM "lat_interp"
#define UVAR   "u10_f"
#define VVAR   "v10_f"

//Options du run incr士ental
int nb_extiter=8;
short inc_save=0;
char dirsave[50]="../obs_float/";
char savename[50]="optim25float-filtre15-inc";
extern double Y3ddf1;
//Declaration pour multirun
void erase_lobs();
short is_activ(int jpfl, int it);
void read_obs(int argv, char *argc[]);
extern int Yobs_insert_data (char *nmmod, int sortie, int iaxe, int jaxe, int kaxe,int pdt, YREAL val);
void run_inc(int argv, char *argc[]);
void div_init();
void init_wind(char fname[],int iter0,int *ptime0);

void appli_start(int argc, char *argv[]){
#ifdef K_FILTER
  //c1=0.5;
  //c2=c3=c4=c5
#endif

  //Init des tableaux
  for (int i=0;i<nlon;i++)
    for (int j=0;j<nlat;j++) {
        mask[i][j]=1;	
      for (int k=0;k<jptfl;k++) {
	umod[i][j][k]=0;
	vmod[i][j][k]=0;
	ubck[i][j][k]=0;
	vbck[i][j][k]=0;
	utotal[i][j][k]=0;
	vtotal[i][j][k]=0;
      }
}
 for (int i=0;i<jptfl;i++)
    for (int j=0;j<jpnfl;j++) {
      piobs[i][j]=0;
      pjobs[i][j]=0;
      piret[i][j]=0;
      pjret[i][j]=0; 
      pmask[i][j]=0;
      }


 /*
char L1[50]="read_obs";
char L2[50]="../obs_float/obs_float_test.dat";
char *L[2];
 L[0]=L1;
 L[1]=L2;
 read_obs(2,L);*/
 //Test de isactiv
 //printf("isactiv(0,0):%d\n",is_activ(0,0));
 //printf("isactiv(1,0):%d\n",is_activ(1,0));
 //printf("isactiv(0,3):%d\n",is_activ(0,3));
 //printf("isactiv(1,3):%d\n",is_activ(1,3));
 //printf("isactiv(0,6):%d\n",is_activ(0,6));
 //printf("isactiv(1,6):%d\n",is_activ(1,6));

  
 // erase_lobs();
}
void before_it(int nit){}
void cost_function(int pdt){}
void adjust_target(){}
void after_it(int nit){
	
	//printf("u_d(9,16)=%f %f %f %f\n",YS1_u_d(9,16),YS1_u_d(10,16),YS1_u_d(10,17),YS1_u_d(9,17));
	}
void forward_before(int ctrp){
}
void forward_after(int ctrp){

}

void backward_before(int ctrp){
}

void backward_after(int ctrp){
	}

short select_io(int indic, char *nmod, int sortie, int iaxe,
		int jaxe, int kaxe, int pdt, YREAL *val){
	//if(indic==YIO_LOADSTATE && !strcmp(nmod,"u")) {
	//printf("s=%d t=%d Yi=%d Yj=%d val=%f\n",sortie,pdt,iaxe,jaxe,*val);	
	//}
	
	return(1);
}
void clear_Yst_nodo(struct Yst_nodo *nobs, int lev, int max) {
  /* lev est le niveau courant (racine=0)
max est le niveau des feuilles soit
4 si dimod=1
5 si dimod=2
6 si dimod=3
dimod est défini au niveau 2 avec dimod=YTabMod[imod].dim


  */
  
  if (lev==max) {
    //on nettoie une feuille (ni frere ni fils)
    free(nobs);
    nobs = NULL ;
  }
  
  else {

    if (lev==2) {
      //on peut déterminer le niveau max
      int dimod=YTabMod[nobs->iind].dim;
      max=dimod+3;
    }

    if (nobs->fils!=NULL && nobs->frere!=NULL) {
      clear_Yst_nodo(nobs->frere,lev,max);
      nobs->frere=NULL;
    }    
    if (nobs->fils!=NULL) {
      clear_Yst_nodo(nobs->fils,lev+1,max);
      nobs->fils=NULL;
    }
    free(nobs);
    nobs=NULL;
  } // else (pas feuille)
  

}

//in case we want to see how it s loading the data we do this above
void erase_lobs() {
  //Efface toute l'arboresence des obs (y compris les ébauches)
  
  int itraj;
  struct Yst_nodo *YRobs = NULL;
  YioInsertObsCtr = 0 ;
  for (itraj=0;itraj<YNBTRAJ;itraj++) {
    //Effacement des obs liées au modul imod

    //  if (YTabMod[itraj].is_target || !YTabMod[itraj].is_cout) {
      YRobs=YTabTraj[itraj].YRobs;
      clear_Yst_nodo(YRobs,0,10);

      YTabTraj[itraj].YRobs=NULL;
      //}

  } //for itraj
  for (int wi = 0; wi < YNBTRAJ; ++wi)
    {
      YTabTraj[wi].YRobs = (struct Yst_nodo*) malloc (sizeof (struct Yst_nodo)); /* init du Root des arborescences */
      YTabTraj[wi].YRobs->frere = YTabTraj[wi].YRobs->fils = NULL;	/* d'observations pour chaque trajectoire */
    }

}


void load_wind(int argv, char *argc[]) {
  /* load_wind windname iter0 time0
     load a wind netcdfile ( from ERAI)
     time0 is the time of the first iteration considered in the file
     (by default time0 is time(0) field in the netcdf file)
     iter0 is the timestep corresponding to time0.
     (by default iter0 is 0)
   */
  if ((argv<2) | (argv >4)) {
    fprintf(stderr,"(load_wind): wrong number of arguments\n");
    return;
  }

  //time0 is a pointer to pass the NULL address in case time0 is
  //not specified in the call of the function
  int *time0=NULL;

  int iter0=0;
  char fname[50];
  sprintf(fname,argc[1]);
  if (argv > 2) {
    iter0 = atoi(argc[2]);
    if (argv > 3) {
      time0 = (int *)malloc(sizeof(int));
      *time0 = atoi(argc[3]);
    }
  }
  init_wind(fname,iter0,time0);
}

void init_wind(char fname[],int iter0,int *ptime0) {
  int ncid,retval;
  int dlatid,dlonid,dtimeid;
  int latid,lonid,timeid,u10id,v10id;
  size_t Nlon,Nlat,Ntime;
  if ((retval = nc_open(fname,NC_NOWRITE, &ncid)))
    ERR(retval);
  if ((retval = nc_inq_dimid(ncid,LONDIM,&dlonid)))
    ERR(retval);
  if ((retval = nc_inq_dimid(ncid,LATDIM,&dlatid)))
    ERR(retval);
  if ((retval = nc_inq_dimid(ncid,"time",&dtimeid)))
    ERR(retval);
  if ((retval = nc_inq_dimlen(ncid,dlonid,&Nlon)))
    ERR(retval);
  if ((retval = nc_inq_dimlen(ncid,dlatid,&Nlat)))
    ERR(retval);
  if ((retval = nc_inq_dimlen(ncid,dtimeid,&Ntime)))
    ERR(retval);
  
  if ((Nlon != nlon) | (Nlat != nlat)) {
   fprintf(stderr,
	   "(init_wind) Wrong dimension (nlat=%d,nlon=%d) for the wind_field %s\n",
	   (int)Nlat, (int)Nlon, fname);
  }
  if ((retval = nc_inq_varid(ncid,LATDIM,&latid)))
    ERR(retval);
  if ((retval = nc_inq_varid(ncid,LONDIM,&lonid)))
    ERR(retval);
  if ((retval = nc_inq_varid(ncid,"time",&timeid)))
    ERR(retval);
  if ((retval = nc_inq_varid(ncid,UVAR,&u10id)))
    ERR(retval);
  if ((retval = nc_inq_varid(ncid,VVAR,&v10id)))
    ERR(retval);
  
  int time[Ntime];
  float (*u10)[nlat][nlon] = new float[Ntime][nlat][nlon];
  float (*v10)[nlat][nlon] = new float[Ntime][nlat][nlon];

  //  float u10[Ntime][Nlat][Nlon];
  //float v10[Ntime][Nlat][Nlon];
 
  if ((retval = nc_get_var_float(ncid,u10id,&u10[0][0][0])))
    ERR(retval);
  
  if ((retval = nc_get_var_float(ncid,v10id,&v10[0][0][0])))
    ERR(retval);

 
  if ((retval = nc_get_var_int(ncid,timeid,&time[0])))
    ERR(retval);
  

  //Load time dimensions
  if (ptime0 == NULL)
    {
      ptime0 = (int *)malloc(sizeof(int));
      *ptime0 = time[0];
    }

  //Copy arrays
  int nt=0;
  int realtime=*ptime0; //time value from time (in hour)
  int timeindex=iter0; //time index for uwind and vwind
  int it;
  YREAL alpha; //interp coefficient
  for (it=0;it<(int)Ntime-1;it++) {
    
// ionterp whil relatime is between 2 step time
    while (time[it]<=realtime && time[it+1]>realtime) {
      

      if (timeindex >= jptfl) {
	fprintf(stderr,"(init_wind) Warning: time values in %s don't fill the jptfl\n",fname);
	return;
      }
      alpha = ((double)realtime - time[it])/(time[it+1]-time[it]);
      for (int ilon=0;ilon<nlon;ilon++)
	for (int ilat=0;ilat<nlat;ilat++) {
	  uwind[ilon][ilat][timeindex] = (1-alpha)*u10[it][ilat][ilon] + alpha*u10[it+1][ilat][ilon];
	  vwind[ilon][ilat][timeindex] = (1-alpha)*v10[it][ilat][ilon] + alpha*v10[it+1][ilat][ilon];
	 
	}
      //To avoid cumulative rounding mistake, realtime is calculate with :
      nt++;
      realtime = *ptime0 + nt*(double)rdtflo/3600;
      timeindex ++;

    } //while time[it]<=realtime
  } //for it
  if (time[it]==realtime && timeindex < jptfl  ) //last step time
    {
      for (int ilon=0;ilon<nlon;ilon++)
	for (int ilat=0;ilat<nlat;ilat++) {
	  uwind[ilon][ilat][timeindex] = u10[it][ilat][ilon] ;
	  vwind[ilon][ilat][timeindex] = v10[it][ilat][ilon] ;
	  
	}
    }
  
}



void read_mask(int argv, char *argc[]) {
char fname[50];
if (argv==1) {
	sprintf(fname,"../obs_float/mask.dat");
}
if (argv==2) {
	sprintf(fname,argc[1]);
}
if (argv>2)
 {
	fprintf(stderr,"(read_mask) Error %d : bad number of arguments\n",argv);
	return;
}
FILE *fid;
fid=fopen(fname,"r");
if (fid==NULL) {
   fprintf(stderr,"(read_mask) Error : unable to open %s\n",fname);
   return;
 }
 int ilon,ilat,status;
float val;
for (ilat=0;ilat<nlat;ilat++)
	for (ilon=0;ilon<nlon;ilon++) {
	status=fscanf(fid,"%f",&val);
	mask[ilon][ilat]=(int)val;
	YS1_mask(ilon,ilat)=mask[ilon][ilat];
if (status!=1) {
	fprintf(stderr,"(read_mask) unable to read mask value (lon=%d,lat=%d)\n",ilon,ilat);
	fclose(fid);	
	return;
}
}
fclose(fid);

}

void read_bck (int argv, char *argc[]) {
/* Read background in a ascii file
   format
   Column 1 (%d) : time step (from 1 to jptfl)
   Column 2 (%d) : lon (Yi) (from 1 to nlon)
   Column 3 (%d) : lat (Yj) (from 1 to nlat)
   Column 4 (%f) : u value
   Column 5 (%f) : v value
*/

if (argv!=2) {
  fprintf(stderr,"(read_bck) Error : read_bck with %d (1 nedded)\n",argv-1);
  fprintf(stderr,"No background read\n");
  return;
 }
 FILE *fid;
 fid=fopen(argc[1],"r");
 if (fid==NULL) {
   fprintf(stderr,"(read_bck) Error : unable to open %s\n",argc[1]);
   return;
 }
 
 int it,ilon,ilat,count;
 count=0;
 YREAL uval,vval;
 int status=5;
 while (status==5) {
   status=fscanf(fid,"%d %d %d %lf %lf",&it,&ilon,&ilat,&uval,&vval);
   if (status!=5) break;
   if (ilon>nlon || ilon<=0 || ilat>nlat || ilat<=0 || it<=0 || it>jptfl) {
     fprintf(stderr,"(read_bck) Error : bad coordinate values in %s (ilon=%d, ilat=%d, it=%d)\n",argc[1],ilon,ilat,it);
     fclose(fid);
     return;
   }
   ubck[ilon-1][ilat-1][it-1]=uval;
   vbck[ilon-1][ilat-1][it-1]=vval;
   count++;
 }
 if (count%(nlon*nlat)!=0) 
   fprintf(stderr,"(read_bck) Warning : only %d data was loaded(nlon*nlat=%d)\n",count,nlon*nlat);
 fclose(fid);
 fprintf(stdout,"(read_bck) %d was loaded as background\n",count);
 
}

void read_obs_2(int argv, char *argc[]) {
  /* Read observation in a ascii file compatible with save_output_rfloat
     format 
     Column 1 (%d) : time step (from 0 to jptfl-1)
     Column 2 (%d) : idfloat (from 0 to jpnfl-1)
     Column 3 (%f) : grid point piret (lat)
     Column 4 (%f) : grid point pjret (lon)
  */
  if (argv!=2) {
    printf("(read_obs) Error : read_obs with %d (1 nedded)\n",argv-1);
    printf("No obs read\n");
    return;
  }
 FILE *fid;
  int count=0;
  fid=fopen(argc[1],"r");
  if (fid==NULL) {
    printf("(read_obs) Error : unable to open %s\n",argc[1]);
    return;
  }
 int it,id;
 YREAL posi,posj;
  int status=4;
  while(status==4) {
    status=fscanf(fid,"%d %d %lf %lf",&it,&id,&posi,&posj);
    if (status!=4) break;
    count++;
    piobs[it][id]=posi;
    pjobs[it][id]=posj;
    pmask[it][id]=1;
  }//while (status==4)
  fclose(fid);
  fprintf(stdout,"(read_obs) %d data were loaded as observations\n",count);
}

void read_obs(int argv, char *argc[]) {
  /* Read observation in a ascii file
     format 
     Column 1 (%d) : dimension (1 : lon(Yi), 2 lat(Yj))
     Column 2 (%d) : time step (from 1 to jptfl)
     Column 3 (%d) : idfloat
     Column 4 (%f) : grid point of the floater
  */


  if (argv!=2) {
    printf("(read_obs) Error : read_obs with %d (1 nedded)\n",argv-1);
    printf("No obs read\n");
    return;
  }
  FILE *fid;
  int count=0;
  fid=fopen(argc[1],"r");
  if (fid==NULL) {
    printf("(read_obs) Error : unable to open %s\n",argc[1]);
    return;
  }
  int i,it,id;
  YREAL pos;
  int status=4;
  while(status==4) {
    status=fscanf(fid,"%d %d %d %lf",&i,&it,&id,&pos);
    if (status!=4) break;
    pjobs[it-1][id-1]=pos;
    status=fscanf(fid,"%d %d %d %lf",&i,&it,&id,&pos);
    if (status!=4 && i!=2) {
      printf("(read_obs) Error : unable to read obs in %s\n",argc[1]);
      return;
    }
    count++;
    piobs[it-1][id-1]=pos;
    pmask[it-1][id-1]=1;
  }
  fclose(fid);
  fprintf(stdout,"(read_obs) %d data were loaded as observations\n",count);
}

void update_uv(){
  int j,k,t;
  for (t=0;t<jtlag;t++)
    for (j=0;j<nlon;j++)
      for (k=0;k<nlat;k++) {
	YS1_u(j,k,t+1)+=YS1_u_d(j,k);
	YS1_v(j,k,t+1)+=YS1_v_d(j,k);
	//printf("u=%f delu=%f \n",YS1_u(j,k),YS1_u_d(j,k));	

}
}

short is_activ(int jpfl, int it) {
  /* return 1 if float jpfl is active after it (stricly) */

  //If forward mode, dont test the flaot ater it
  if (tassim==FORW)
    return 1;
  
  int jptend=it+jtlag+1;  
  it++;
  
  while(it<jptend && pmask[it][jpfl]==0)
    it++;
  return(it<jptend && pmask[it][jpfl]==1);
}

void load_eb(int iti, int itn) {
  /*Load background from ubck and vbck from time iti to itn*/
  int j,k,it;
    for (j=0;j<nlon;j++)
      for (k=0;k<nlat;k++) {
	for (it=iti;it<itn;it++)
	  {
	    //+1 to tak uptime into account
	    YS1_u(j,k,it-iti+1)=ubck[j][k][it];
	    YS1_v(j,k,it-iti+1)=vbck[j][k][it];
	    YS1_uwind(j,k,it-iti+1)=uwind[j][k][it];
	    YS1_vwind(j,k,it-iti+1)=vwind[j][k][it];
	    
	  }
#ifdef K_FILTER
	YS1_uc_d(j,k)=0;
	YS1_vc_d(j,k)=0;
	// Yobs_insert_data (char *nmmod, int sortie, int iaxe, int jaxe, int kaxe,int pdt, YREAL val)
	
	Yobs_insert_data("uc_d",0,j,k,0,-1,0);
	Yobs_insert_data("vc_d",0,j,k,0,-1,0);
#else
	Yobs_insert_data("u_d",0,j,k,0,-1,0);
	Yobs_insert_data("v_d",0,j,k,0,-1,0);
	
#endif
	
      }
}

void save_uv(int iti, int itn) {
  /* save u,v fields in umod,vmod 
   and save piret,pjret*/
  int j,k,it;
  int Yifloat=0;
  for (it=iti;it<itn;it++) {
    Yifloat=0;
    for (j=0;j<nlon;j++)
      for (k=0;k<nlat;k++) {
	umod[j][k][it]=YS1_u(j,k,it-iti+1);
	vmod[j][k][it]=YS1_v(j,k,it-iti+1);
	utotal[j][k][it]=YS1_utot(j,k,it-iti+1);
	vtotal[j][k][it]=YS1_vtot(j,k,it-iti+1);
#ifdef UPDATE_BCK
	ubck[j][k][it]=YS1_u(j,k,it-iti+1);
	vbck[j][k][it]=YS1_v(j,k,it-iti+1);
#endif
      }
    for (j=0;j<jpnfl;j++) 
      if (pmask[iti][j]==1 && is_activ(j,iti)>0 && it>iti) {
	pjret[it][j]=YS1_r_float(Yifloat,it-iti);
	piret[it][j]=YS2_r_float(Yifloat,it-iti);
	Yifloat++;
      }
  }
}

void save_output_rfloat (int argc, char *argv[]) {
  FILE *fid;
  fid=fopen(argv[1],"w");
  if (fid==NULL) {
    printf("\nfailed to open %s",argv[1]);
    exit(3);
  }
  int j,it;
  for (j=0;j<jpnfl;j++)
    for (it=0;it<jptfl;it++)
      
      fprintf(fid,"%d %d %f %f\n",it,j,piret[it][j],pjret[it][j]);
	
					     
  fclose(fid);

}


void save_output_wind (int argc, char *argv[]) {
  //Function used only for test
FILE *fid;
  fid=fopen(argv[1],"w");
  if (fid==NULL) {
    printf("\nfailed to open %s",argv[1]);
    exit(3);
  }
  int j,k,it;
    for (it=0;it<jptfl;it++)
      for (j=0;j<nlon;j++)
	for (k=0;k<nlat;k++) {
	  fprintf(fid,"%d %d %d %f %f\n",it,j,k,uwind[j][k][it],vwind[j][k][it]);
	}
					     
  fclose(fid);

}

void save_output_uv (int argc, char *argv[]) {
  FILE *fid;
  fid=fopen(argv[1],"w");
  if (fid==NULL) {
    printf("\nfailed to open %s",argv[1]);
    exit(3);
  }
  int j,k,it;
    for (it=0;it<jptfl;it++)
      for (j=0;j<nlon;j++)
	for (k=0;k<nlat;k++) {
	  fprintf(fid,"%d %d %d %f %f\n",it,j,k,umod[j][k][it],vmod[j][k][it]);
	}
					     
  fclose(fid);

}

void save_output_uvtot (int argc, char *argv[]) {
  FILE *fid;
  fid=fopen(argv[1],"w");
  if (fid==NULL) {
    printf("\nfailed to open %s",argv[1]);
    exit(3);
  }
  int j,k,it;
    for (it=0;it<jptfl;it++)
      for (j=0;j<nlon;j++)
	for (k=0;k<nlat;k++) {
	  fprintf(fid,"%d %d %d %f %f\n",it,j,k,utotal[j][k][it],vtotal[j][k][it]);
	}
					     
  fclose(fid);

}

void save_output_uinter (int argc, char *argv[]) {
  FILE *fid;
  fid=fopen(argv[1],"w");
  if (fid==NULL) {
    printf("\nfailed to open %s",argv[1]);
    exit(3);
  }
  int j,it;
  for (j=0;j<jpnfl;j++)
    for (it=0;it<jptfl;it++)
      
      fprintf(fid,"%d %d %f %f\n",it,j,piret[it][j],pjret[it][j]);
	
					     
  fclose(fid);

}

void div_init() {
  //Make pseudo-obs of divergence to constrain
  int i,j,it;
  for (it=0;it<jtlag;it++)
    for (j=0;j<nlon;j++)
      for (i=0;i<nlat;i++) {
	Yobs_insert_data("cout_div",0,j,i,0,it,0);
      }

}

void load_init(int it) {
  /*Load floater position at time it as init.
  Only floats that have another position after it
  Warning : nbre de flotteurs maxiums : nfloat */
  int jfl;
  int Yifloat=0;
  int nfobs=0;
  int ninit=0;
  int jptend=it+1+jtlag;
  for (jfl=0;jfl<jpnfl;jfl++) {
    nfobs=0;
    ninit=0;
    if (pmask[it][jfl]==1 && is_activ(jfl,it)>0) {
      //Chargemente de l'init
      YS1_r_float(Yifloat,0)=pjobs[it][jfl];
      YS2_r_float(Yifloat,0)=piobs[it][jfl];
      ninit++;
      //Chargement des obs
      for (int itfl=it+1;itfl<jptend;itfl++) {
	if (pmask[itfl][jfl]==1) {
	  // Yobs_insert_data (char *nmmod, int sortie, int iaxe, int jaxe, int kaxe,int pdt, YREAL val)
	  Yobs_insert_data("r_cout_d",0,Yifloat,0,0,itfl-it,pjobs[itfl][jfl]);
  	  Yobs_insert_data("r_cout_d",1,Yifloat,0,0,itfl-it,piobs[itfl][jfl]);
        nfobs++;
	} //if pmask==1
	} //for itfl
     
      Yifloat++; 
      printf("--Float nr %d : %d initial position / %d obs loaded\n",Yifloat,ninit,nfobs); 
    } //if pmask==1

    } //for jfl
  
  
  }

void myforward() {
  int niti=0; //Temps init
  int nitn=jptfl-1; //Temps fin
  char sactiv[20]="activ";
  char sMD[20]="M";
  char sonly[20]="only";
  char *liste[3];
  liste[0]=sactiv;
  liste[1]=sMD;
  liste[2]=sonly;
  
  //Mode forward
  tassim=FORW;

  //Effacement des obs potentielles
  erase_lobs();
  
  // Chargement de toutes les init et obs dans les bon pas de temps
  load_init(niti);
  
  //obs pour divergence
  div_init();
 
  //Réglage de l'ébauche
   load_eb(niti,nitn);
 
   //Forward
   strcpy(liste[1],"M");
   Yactraj(3, liste);
   Yset_modeltime(0);
   before_it(1);

   Yforward(-1, 0);

   //Save outputs
   save_uv(niti,nitn);

  //On se remet au mode ASSIM par défaut
  tassim=ASSIM;
}

void multirun() {
  int niti=0; //Temps init
  int nitn=jtlag;//Temps fin
    while(nitn<jptfl) {
      
      //Effacement de toutes les obs précédentes
      erase_lobs();

      // Chargement de toutes les init et obs dans les bon pas de temps
      load_init(niti);

  
      //obs pour divergence
      div_init();

      // Réglage de l'ébauche
      load_eb(niti,nitn);

      // Run_inc
      run_inc(0,NULL);

      // Sauvegarde du résultat dans les tableaux
      save_uv(niti,nitn);


      niti=nitn;
      nitn=niti+jtlag;
    } //while nitn<jptfl
}

void erase_udvd() {
  int j,k;
  for (j=0;j<nlon;j++)
	for (k=0;k<nlat;k++) {
#ifdef K_FILTER
	  YS1_uc_d(j,k)=0;
	  YS1_vc_d(j,k)=0;
#else	  
	  YS1_u_d(j,k)=0;
	  YS1_v_d(j,k)=0;
#endif
}
}
//void load_aviso(int argc, char *argv[]){
	
//	}

void run_inc(int argv, char *argc[]) {
//Run the incremental optimisation
//1 forward of the complete model
//2 initialize du et dv to zero
//3 minimize the incremental cost function
//4 update u and v

/*
Options
nb_extiter : number of extern loop (default=6)
inc_save : save option
	0  : no save
	1 (default): save after each extern loop r_float,u and v
dirsave : directory in case inc_save>0 (default="../obs_float/")
savename : basename of save fils (default "optim")
*/
char filesave[100];
int i;

char sactiv[20]="activ";
char sMD[20]="M";
char sonly[20]="only";
char *liste[3];
liste[0]=sactiv;
liste[1]=sMD;
liste[2]=sonly;
/*Check M1QN3 config*/
 if (YNbItRun<=0)
		{	 printf("runm(2): number of run iteration not seted; use set_nbiter please\n");
			 //return(0);
		}
	if (Y3ddf1<=0)
		{	printf("runm(2): expected positive fcost decrease missed; use setm_ddf1\n");
			 //return(0);
		}
	if (YioInsertObsCtr<0)
		   printf("runm(2): warning : oh oh, run with no obs !!! \n");
		
	YTypeAdjust = ADJUST_M1QN3; //d'office avec M1QN3
	
//Savestate config
 YioModulot = OFF; //On sauvegarde tous les pas de temps
    YioWrite = ON;
    YioRead= OFF;
   // Yio_savestate(cdes[1], cdes[3], 0, cdes[7]);
    YioState=0 ;//Save all states
    YioBin=OFF; //ascii output
    YioAscii=ON; //ascii output
    YioAxes=ON; //save axe numbers
    printf("Run with %d ext_iter with %d obs\n",nb_extiter,YioInsertObsCtr);
for (i=0;i<nb_extiter;i++) {
printf("Ext loop %d/%d\n",i+1,nb_extiter);
     strcpy(liste[1],"M");
	 Yactraj(3, liste);
	 Yset_modeltime(0);
	 before_it(1);
	 //printf("---forward(i=%d)---\n",i);
	 Yforward(-1, 0);
	 
	 if (inc_save==1 && i>0) {
	  //save rfloat
  	  YioTime=ON;
   	  sprintf(filesave,"%sr_float_%s_%d.dat",dirsave,savename,i);
	  Yio_savestate("r_float","i",0,filesave);
	 }
	     strcpy(liste[1],"D");
	 Yactraj(3,liste);
	 Yset_modeltime(0);
	 
	
	Y3run ('0');
#ifdef K_FILTER
	//compute values for u_d and v_d
	strcpy(liste[1],"Tfil");
	Yactraj(3,liste);
	Yset_modeltime(0);
	before_it(1);
	Yforward(-1, 0);
	strcpy(liste[1],"T_euler_d");
	Yactraj(3,liste);
	Yset_modeltime(0);
	before_it(1);
	Yforward(-1, 0);
#endif


    update_uv();
    erase_udvd();

    if (inc_save==1) {
   
    
    //save u
    YioTime=ON;
    sprintf(filesave,"%su%s%d.dat",dirsave,savename,i+1);
    Yio_savestate("u","ij",0,filesave);
    
    //save v
    sprintf(filesave,"%sv%s%d.dat",dirsave,savename,i+1);
    Yio_savestate("v","ij",0,filesave);
    
    }
    }
    /*End of the optimization, we run another time the model to compute the final value of r_float
    */
     strcpy(liste[1],"M");
    Yactraj(3, liste);
	 Yset_modeltime(0);
	 before_it(1);
	 Yforward(-1, 0);
 if (inc_save==1) {
	  //save rfloat
  	  YioTime=ON;
   	  sprintf(filesave,"%sr_float_%s_%d.dat",dirsave,savename,nb_extiter);
	  Yio_savestate("r_float","i",0,filesave);
	 }
}


